<?php
// Kreditkarten Type Deklaration. damit es einheitlich ist
// wird auch zur Anzeige benutzt
define('WIRE_CCARD_TYPE_VISA', 'Visa');
define('WIRE_CCARD_TYPE_MASTERCARD', 'Mastercard');
define('WIRE_CCARD_TYPE_JCB', 'JCB');
define('WIRE_CCARD_TYPE_AMEX', 'Amercian Express');
define('WIRE_CCARD_TYPE_MAESTRO', 'Maestro');

define('CC_ISSUENUMBER_MIN_LENGTH', '1');
define('CC_CVV_MIN_LENGTH', '3');

define('WC_CLEAR_GREEN', '3');
define('WC_CLEAR_YELLOW', '2');
define('WC_CLEAR_RED', '1');
define('WC_CLEAR_BLACK', '0');

define('WC_LIVE_URL', 'https://c3.wirecard.com/risk/verify');
define('WC_DEMO_URL', 'https://c3-test.wirecard.com/risk/verify');

$boniValues = array(
  WC_CLEAR_GREEN  => 'Grn',
  WC_CLEAR_YELLOW => 'Gelb',
  WC_CLEAR_RED    => 'Rot',
  WC_CLEAR_BLACK  => 'Unbekannt'
);

class wirecard {
  var $cc_type, $cc_number, $cc_expiry_month, $cc_expiry_year;
  var $standardStoplight = WC_CLEAR_YELLOW;
  var $clearingTable = 'wirecard_clearing';

  var $proxyhost  = '';
  var $proxyport  = '';
  var $proxyuser  = '';
  var $proxypass  = '';
  /*
  var $proxyhost  = '';
  var $proxyport  = '';
  var $proxyuser  = '';
  var $proxypass  = '';
   */

  function wirecard()/*{{{*/
  {
    if (MODULE_WIRECARD_RISK_MODE == 'demo'){
      define ('MODULE_WIRECARD_RISK_URL', WC_DEMO_URL);
    } else {
      define ('MODULE_WIRECARD_RISK_URL', WC_LIVE_URL);
    }
  }/*}}}*/

  function validate($number, $expiry_m, $expiry_y) /*{{{*/
  {
    $this->cc_number = ereg_replace('[^0-9]', '', $number);

    if (ereg('^4[0-9]{12}([0-9]{3})?$', $this->cc_number)) {
      $this->cc_type = WIRE_CCARD_TYPE_VISA;
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_VISA) != 'true')
        return -8;
    }
    elseif (ereg('^5[1-5][0-9]{14}$', $this->cc_number)) {
      $this->cc_type = WIRE_CCARD_TYPE_MASTERCARD;
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_MASTERCARD) != 'true')
        return -8;
    }
    elseif (ereg('^3[47][0-9]{13}$', $this->cc_number)) {
      $this->cc_type = WIRE_CCARD_TYPE_AMEX;
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_AMEX) != 'true')
        return -8;
    }
    elseif (ereg('^3(0[0-5]|[68][0-9])[0-9]{11}$', $this->cc_number)) {
      $this->cc_type = 'Diners Club';
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_DINERSCLUB) != 'true')
        return -8;
    }
    elseif (ereg('^6011[0-9]{12}$', $this->cc_number)) {
      $this->cc_type = 'Discover';
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_DISCOVERNOVUS) != 'true')
        return -8;
    }
    elseif (ereg('^(3[0-9]{4}|2131|1800)[0-9]{11}$', $this->cc_number)) {
      $this->cc_type = WIRE_CCARD_TYPE_JCB;
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_JCB) != 'true')
        return -8;
    }
    elseif (ereg('^5610[0-9]{12}$', $this->cc_number)) {
      $this->cc_type = 'Australian BankCard';
      if (strtolower(MODULE_PAYMENT_WIRECARD_CCARD_ACCEPT_OZBANKCARD) != 'true')
        return -8;
    } else {
      return -1;
    }

    if (is_numeric($expiry_m) && ($expiry_m > 0) && ($expiry_m < 13)) {
      $this->cc_expiry_month = $expiry_m;
    } else {
      return -2;
    }

    $current_year = date('Y');
    $expiry_y = substr($current_year, 0, 2).$expiry_y;
    if (is_numeric($expiry_y) && ($expiry_y >= $current_year) && ($expiry_y <= ($current_year +10))) {
      $this->cc_expiry_year = $expiry_y;
    } else {
      return -3;
    }

    if ($expiry_y == $current_year) {
      if ($expiry_m < date('n')) {
        return -4;
      }
    }

    return $this->is_valid();
  }/*}}}*/

  function is_valid() /*{{{*/
  {
    $cardNumber = strrev($this->cc_number);
    $numSum = 0;

    for ($i = 0; $i < strlen($cardNumber); $i ++) {
      $currentNum = substr($cardNumber, $i, 1);

      // Double every second digit
      if ($i % 2 == 1) {
        $currentNum *= 2;
      }

      // Add digits of 2-digit numbers together
      if ($currentNum > 9) {
        $firstNum = $currentNum % 10;
        $secondNum = ($currentNum - $firstNum) / 10;
        $currentNum = $firstNum + $secondNum;
      }

      $numSum += $currentNum;
    }

    // If the total has no remainder it's OK
    return ($numSum % 10 == 0);
  }/*}}}*/

  function doWCRequest()/*{{{*/
  {
    $customerId = $_SESSION['customer_id'];
    $cusData = $this->getCustomerData($customerId);
    $cusData['customers_telephone'] = preg_replace('/[^a-zA-Z0-9]/', '', $cusData['customers_telephone']);

    if (preg_match('/^[^0-9]+.*\\r*\\n*.*/', $cusData['entry_street_address'])){
      $cus_nr              = preg_replace('/[^0-9]*(.*)\\r*\\n*.*/', '$1', $cusData['entry_street_address']);
      $cus_street          = str_replace($cus_nr,'',$cusData['entry_street_address']);
    } else {
      $cus_nr              = preg_replace('/([0-9\-]*) [^0-9]*\\r*\\n*.*/', '$1', $cusData['entry_street_address']);
      $cus_street          = str_replace($cus_nr,'',$cusData['entry_street_address']);
    }
    $cus_country = $this->getCustomerCountry($cusData['entry_country_id']);
    // Wenn Kunde nicht aus DE dann GRN
    if (strtolower($cus_country) != 'de') return WC_CLEAR_GREEN;

    $data = array(
      'mode'                    => MODULE_WIRECARD_RISK_MODE, # test, live, demo
      'solution'                => 'risk', # eft, cc, risk
      'timeout'                 => '0', # 0 - 999999 in Seconds
      'version'                 => '1.0',
      'entity-id'               => MODULE_WIRECARD_RISK_ENTITY_ID, # Unique Merchant identifier
      'request-id'              => md5(MODULE_WIRECARD_RISK_ENTITY_ID.time().$customerId.$_SERVER['REMOTE_ADDR']), # Unique Request ID of Merchant
      'reference-response-id'   => '', # Previous eresponse unique id
      'first-name'              => $cusData['customers_firstname'],
      'middle-name'             => '',
      'last-name'               => $cusData['customers_lastname'],
      'gender-code'             => strtoupper($cusData['customers_gender']),
      'tax-identification-num'  => '123456789',
      'phone'                   => '+49('.substr($cusData['customers_telephone'],0, 4).')'.substr($cusData['customers_telephone'],4),
      'mobile-phone'            => '',
      'ip-address'              => $_SERVER['REMOTE_ADDR'],
      'email'                   => $cusData['customers_email_address'],
      'birth-date'              => substr($cusData['customers_dob'],0,10),
      'customer-id'             => $customerId,
      'street-name'             => $cus_street,
      'street-number'           => $cus_nr,
      'apartment-number'        => '',
      'zip-code'                => $cusData['entry_postcode'],
      'city'                    => $cusData['entry_city'],
      'country'                 => $cus_country
    );
    // Live Test gegen das Demo System
    #$data['mode'] = 'live';
    #echo '<pre>'.print_r($data, true).'</pre>';
    $replacement = array();
    foreach($data AS $k => $v){
      $replacement['{VAR_'.strtoupper($k).'}'] = utf8_encode($v);
    }
    #echo '<pre>'.print_r($replacement, true).'</pre>';

    $xml = '<?xml version="1.0" encoding="UTF-8"?>
      <risk-request mode="{VAR_MODE}" solution="{VAR_SOLUTION}" timeout="{VAR_TIMEOUT}" version="{VAR_VERSION}">
      <application>
      <entity-id>{VAR_ENTITY-ID}</entity-id>
      <request-id>{VAR_REQUEST-ID}</request-id>
      </application>
      <verify>
      <first-name>{VAR_FIRST-NAME}</first-name>
      <last-name>{VAR_LAST-NAME}</last-name>
      <gender-code>{VAR_GENDER-CODE}</gender-code>
      <tax-identification-num>{VAR_TAX-IDENTIFICATION-NUM}</tax-identification-num>
      <phone>{VAR_PHONE}</phone>
      <ip-address>{VAR_IP-ADDRESS}</ip-address>
      <email>{VAR_EMAIL}</email>
      <birth-date>{VAR_BIRTH-DATE}</birth-date>
      <customer-id>{VAR_CUSTOMER-ID}</customer-id>
      <current-address>
      <street-name>{VAR_STREET-NAME}</street-name>
      <street-number>{VAR_STREET-NUMBER}</street-number>
      <zip-code>{VAR_ZIP-CODE}</zip-code>
      <city>{VAR_CITY}</city>
      <country>{VAR_COUNTRY}</country>
      </current-address>
      </verify>
      </risk-request>';

    $xml = strtr($xml, $replacement);
    # Anfrage
    #echo '<pre>'.htmlentities($xml).'</pre>';

    // Proxydaten prfen
    $prox = $this->proxyhost.$this->proxyport.$this->proxyuser.$this->proxypass;
    $needProxy = false;
    if (!empty($prox)) $needProxy = true;
    
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_URL, MODULE_WIRECARD_RISK_URL);
    curl_setopt ($ch, CURLOPT_HEADER, 0);
    curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 60);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST,0);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt ($ch, CURLOPT_USERAGENT, "WireCard Clearing Request");
    curl_setopt ($ch, CURLOPT_FAILONERROR, 1); 
    #curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_USERPWD, MODULE_WIRECARD_RISK_USER_ID.':'.MODULE_WIRECARD_RISK_PASSWORD);
    $headers[0] = 'Business Case Signature : ' . MODULE_WIRECARD_RISK_BUSINESS_CASE_SIGNATURE;
    $headers[1] = 'Content-Type : text/xml';
    curl_setopt ($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt ($ch, CURLOPT_POST, 1);
    curl_setopt ($ch, CURLOPT_POSTFIELDS, $xml);

    if ($needProxy){
      curl_setopt($ch, CURLOPT_PROXY, $this->proxyhost.':'.$this->proxyport);
      curl_setopt($ch, CURLOPT_PROXYUSERPWD, $this->proxyuser.':'.$this->proxypass);
    }
    
    $response = curl_exec ($ch);

    # Rckgabe
    #echo '<pre>'.htmlentities($response).'</pre>';

    if (curl_error($ch)){
      echo '<!-- Wirecard CURL Error: '.curl_error($ch).'-->';
      return WC_CLEAR_BLACK;
    }

    curl_close ($ch);

    $retarr = array();
    $retarr = $this->decodeXML($response);

    $stoplight = $this->calculateStoplight($retarr);
    $this->setCustomerStopLight($customerId, $stoplight);
    return $stoplight;
  }/*}}}*/

  function calculateStoplight($retarr)/*{{{*/
  {
    if($retarr['return-code'] == 0) {
      if(strlen($retarr['score-class-code']) > 0) {
        return $retarr['score-class-code'];
      } elseif (strlen($retarr['score']) > 0) {
        if($retarr['score']>0 && $retarr['score']<925) {
          return WC_CLEAR_YELLOW;
        }elseif($retarr['score']>925 && $retarr['score']<99000){
          return WC_CLEAR_GREEN;
        }elseif ($retarr['score']>99000) {
          return WC_CLEAR_RED;
        }else {
          return WC_CLEAR_BLACK;
        }
      } else {
        return WC_CLEAR_BLACK;
      }
    } elseif ($retarr['return-code'] == 508) {
      return 508;
    } elseif ($retarr['return-code'] == 507) {
      return 507;
    } elseif ($retarr['return-code'] == 250) {
      return 250;
    } else {
      return WC_CLEAR_BLACK;
    }
  }/*}}}*/

  function doClearing()/*{{{*/
  {
    // Wenn RISK Prfung deaktiviert dann nix machen.
    if (MODULE_WIRECARD_RISK_STATUS == 'false') return true;
    $customerId = $_SESSION['customer_id'];
    $stoplight = $this->standardStoplight;
    $sl = $this->doWCRequest();
    if ($sl){
      $stoplight = $sl;
    } else {
      return false;
    }
    $this->setCustomerStopLight($customerId, $stoplight);
    return true;
  }/*}}}*/

  function dbTableExists($table)/*{{{*/
  {
    if (empty($table)) return false;
    $checkTableQuery = tep_db_query('SHOW TABLES LIKE "'.addslashes($table).'"');
    $checkTable = tep_db_fetch_array($checkTableQuery);
    return (!empty($checkTable));
  } /*}}}*/

  function getCustomerStopLight($customerId)/*{{{*/
  {
    if ($customerId <= 0) return false;

    // Wenn das Clearing Modul nicht installiert und clearing Tabelle nicht existiert
    if (!$this->dbTableExists($this->clearingTable)) return $this->standardStoplight;

    $sql = 'SELECT `stoplight` FROM `'.$this->clearingTable.'`
      WHERE `customerId` = "'.addslashes($customerId).'"
      ';
    $tmp = tep_db_fetch_array(tep_db_query($sql));
    if ($tmp['stoplight'] == '') $tmp['stoplight'] = 0;
    return $tmp['stoplight'];
  }/*}}}*/

  function setCustomerStopLight($customerId, $stoplight)/*{{{*/
  {
    if ($customerId <= 0) return false;
    if ($stoplight < 0 && $stoplight > 3) return false;

    $tmp = $this->getCustomerStopLight($customerId);

    $sql = $sqlWhere = '';
    if (!isset($tmp['stoplight']) && empty($tmp)){
      $sql.= 'INSERT INTO ';
    } else {
      $sql.= 'UPDATE ';
      $sqlWhere = 'WHERE `customerId` = "'.addslashes($customerId).'" ';
    }
    $sql.= '`'.$this->clearingTable.'`
      SET `customerId`  = "'.addslashes($customerId).'",
        `stoplight`       = "'.addslashes($stoplight).'"
        '.$sqlWhere;
    return tep_db_query($sql);
  }/*}}}*/

  function getCustomerData($id)/*{{{*/
  {
    $sql = 'SELECT *
      FROM `customers` c
      LEFT JOIN `address_book` a
      ON c.`customers_default_address_id` = a.`address_book_id`
      WHERE c.`customers_id` = "'.addslashes($id).'"
      ';
    $customer_dob = tep_db_query($sql);
    $attributes_values = tep_db_fetch_array($customer_dob);
    return $attributes_values;
  }/*}}}*/

  function getCustomerCountry($country)/*{{{*/
  {
    $country_query  = tep_db_query('SELECT `countries_iso_code_2` FROM `countries` WHERE `countries_id` = "'.$country.'"');
    $country_res    = tep_db_fetch_array($country_query);
    $cus_country    = $country_res['countries_iso_code_2'];
    return $cus_country;
  }/*}}}*/

  function decodeXML($xmlstg) /*{{{*/
  {
    preg_match_all ("(<([a-z0-9\-]+)>([^<>]*?)</[a-z0-9\-]+>)i", $xmlstg, $out, PREG_SET_ORDER);
    $n = 0;
    while (isset($out[$n])) {
      $retarr[$out[$n][1]] = strip_tags($out[$n][2]);
      $n++;
    }

    return $retarr;
  }/*}}}*/

  function getTotalAmount()/*{{{*/
  {
    global $order;
    // Wenn die UST mit ausgewiesen wird, mu diese auch mit auf den Betrag gerechnet werden.
    if ($_SESSION['customers_status']['customers_status_show_price_tax'] == 0 && $_SESSION['customers_status']['customers_status_add_tax_ot'] == 1) {
      $total = floor(round((($order->info['total'] + $order->info['tax']) * 100), 1));
    } else {
      $total = floor(round($order->info['total'] * 100, 1));
    }
    return (int)$total;
  }/*}}}*/

  function getCustomerXMLData($post, $business_case_signature, $transaction_id, $amount, $currency, $country_code)/*{{{*/
  {
    global $order;
    if(function_exists('iconv'))
    {
      define(CHARSET, iconv_get_encoding('internal_encoding'));
      $cc_owner = iconv(iconv_get_encoding('internal_encoding'), 'ASCII', $post['cc_owner']);
      $cc_number = iconv(iconv_get_encoding('internal_encoding'), 'ASCII', $post['cc_number']);
      $cc_checkcode = iconv(iconv_get_encoding('internal_encoding'), 'ASCII', $post['cc_checkcode']);
      $cc_number = $post['cc_number'];
      $cc_checkcode = $post['cc_checkcode'];
      $cc_expdate_month = $post['cc_expdate_month'];
      $cc_expdate_year = (strlen($post['cc_expdate_year']) == 2 ? '20' . $post['cc_expdate_year'] : $post['cc_expdate_year']);
      $cc_issuenumber = $post['cc_issuenumber'];
      $cc_start_month = $post['cc_start_month'];
      $cc_start_year = (strlen($post['cc_start_year']) == 2 ? '20' . $post['cc_start_year'] : $post['cc_start_year']);

      $usage = $transaction_id;
      $firstname = iconv(CHARSET, 'UTF-8', $order->customer['firstname']);
      $lastname = iconv(CHARSET, 'UTF-8', $order->customer['lastname']);
      $street_address = iconv(CHARSET, 'UTF-8', $order->customer['street_address']);
      $suburb = iconv(CHARSET, 'UTF-8', $order->customer['suburb']);
      $city = iconv(CHARSET, 'UTF-8', $order->customer['city']);
      $postcode = iconv(CHARSET, 'UTF-8', $order->customer['postcode']);
      $state = iconv(CHARSET, 'UTF-8', $order->customer['state']);
      $country = $order->customer['country']['iso_code_2'];
      $telephone = iconv(CHARSET, 'UTF-8', $order->customer['telephone']);
      $email_address = iconv(CHARSET, 'UTF-8', $order->customer['email_address']);
    } else {
      $cc_owner = utf8_encode($post['cc_owner']);
      $cc_number = utf8_encode($post['cc_number']);
      $cc_checkcode = utf8_encode($post['cc_checkcode']);
      $cc_number = $post['cc_number'];
      $cc_checkcode = $post['cc_checkcode'];
      $cc_expdate_month = $post['cc_expdate_month'];
      $cc_expdate_year = (strlen($post['cc_expdate_year']) == 2 ? '20' . $post['cc_expdate_year'] : $post['cc_expdate_year']);
      $cc_issuenumber = $post['cc_issuenumber'];
      $cc_start_month = $post['cc_start_month'];
      $cc_start_year = (strlen($post['cc_start_year']) == 2 ? '20' . $post['cc_start_year'] : $post['cc_start_year']);

      $usage = $transaction_id;
      $firstname = utf8_encode($order->customer['firstname']);
      $lastname = utf8_encode($order->customer['lastname']);
      $street_address = utf8_encode($order->customer['street_address']);
      $suburb = utf8_encode($order->customer['suburb']);
      $city = utf8_encode($order->customer['city']);
      $postcode = utf8_encode($order->customer['postcode']);
      $state = utf8_encode($order->customer['state']);
      $country = $order->customer['country']['iso_code_2'];
      $telephone = utf8_encode($order->customer['telephone']);
      $email_address = utf8_encode($order->customer['email_address']);
    }
    $data = array(
      'business_case_signature' => $business_case_signature,
      'transaction_id'          => $transaction_id,
      'amount'                  => $amount,
      'currency'                => $currency,
      'country_code'            => $country_code,
      'cc_number'               => $cc_number,
      'cc_expdate_year'         => $cc_expdate_year,
      'cc_expdate_month'        => $cc_expdate_month,
      'cc_checkcode'            => $cc_checkcode,
      'cc_owner'                => $cc_owner,
      'street_address'          => $street_address,
      'city'                    => $city,
      'postcode'                => $postcode,
      'country'                 => $country,
      'email_address'           => $email_address,
      'date'                    => date('Y-m-d'),
      'usage'                   => $usage,
      'ip'                      => $_SERVER['REMOTE_ADDR'],
      'firstname'               => $firstname,
      'lastname'                => $lastname,
    );
    if ($post['cc_type'] == WIRE_CCARD_TYPE_MAESTRO){
      $data['MAESTRO_DATA'] = '';
      if ($cc_start_year != ''){
        $data['MAESTRO_DATA'].= '<CardStartYear>'.$cc_start_year.'</CardStartYear>';
      }
      if ($cc_start_month != ''){
        $data['MAESTRO_DATA'].= '<CardStartMonth>'.$cc_start_month.'</CardStartMonth>';
      }
      if ($cc_issuenumber != ''){
        $data['MAESTRO_DATA'].= '<CardIssueNumber>'.$cc_issuenumber.'</CardIssueNumber>';
      }
    }
    return $data;
  }/*}}}*/

  function getPaymentFinishXML($data)/*{{{*/
  {
    $replacement = array();
    foreach($data AS $k => $v){
      $replacement['{VAR_'.strtoupper($k).'}'] = utf8_encode($v);
    }
    $text_xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<WIRECARD_BXML xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" xsi:noNamespaceSchemaLocation=\"wirecard.xsd\">
  <W_REQUEST>
    <W_JOB>
      <JobID>{VAR_TRANSACTION_ID}</JobID>
      <BusinessCaseSignature>{VAR_BUSINESS_CASE_SIGNATURE}</BusinessCaseSignature>
      <FNC_CC_TRANSACTION>
        <FunctionID>{VAR_TRANSACTION_ID}</FunctionID>
        <CC_TRANSACTION mode=\"live\">
          <TransactionID>{VAR_TRANSACTION_ID}</TransactionID>
          <SalesDate>{VAR_DATE}</SalesDate>
          <GuWID>{VAR_GUWID}</GuWID>
          <CommerceType>eCommerce</CommerceType>
          <Amount minorunits=\"2\">{VAR_AMOUNT}</Amount>
          <Currency>{VAR_CURRENCY}</Currency>
          <CountryCode>{VAR_COUNTRY_CODE}</CountryCode>
          <Usage>{VAR_USAGE}</Usage>
          <RECURRING_TRANSACTION>
            <Type>Initial</Type>
          </RECURRING_TRANSACTION>
          <CREDIT_CARD_DATA>
            <CreditCardNumber>{VAR_CC_NUMBER}</CreditCardNumber>
            <ExpirationYear>{VAR_CC_EXPDATE_YEAR}</ExpirationYear>
            <ExpirationMonth>{VAR_CC_EXPDATE_MONTH}</ExpirationMonth>
            <CardHolderName>{VAR_CC_OWNER}</CardHolderName>
          </CREDIT_CARD_DATA>
          <THREE-D_SECURE>
            <PARes>{VAR_PARES}</PARes>
          </THREE-D_SECURE>
          <CORPTRUSTCENTER_DATA>
            <ADDRESS>
              <FirstName>{VAR_FIRSTNAME}</FirstName>
              <LastName>{VAR_LASTNAME}</LastName>
              <Address1>{VAR_STREET_ADDRESS}</Address1>
              <City>{VAR_CITY}</City>
              <ZipCode>{VAR_CITY}</ZipCode>
              <Country>{VAR_COUNTRY}</Country>
              <Email>{VAR_EMAIL_ADDRESS}</Email>
            </ADDRESS>
          </CORPTRUSTCENTER_DATA>
        </CC_TRANSACTION>
      </FNC_CC_TRANSACTION>
    </W_JOB>
  </W_REQUEST>
</WIRECARD_BXML>";
    $text_xml = strtr($text_xml, $replacement);
    return $text_xml;
  }/*}}}*/
  
  function getPaymentXML($data, $is3DS)/*{{{*/
  {
    $replacement = array();
    foreach($data AS $k => $v){
      $replacement['{VAR_'.strtoupper($k).'}'] = utf8_encode($v);
    }
    if (!array_key_exists('{VAR_MAESTRO_DATA}', $replacement)) $replacement['{VAR_MAESTRO_DATA}'] = '';
    if (array_key_exists('{VAR_GUWID}', $replacement)) {
      $replacement['{VAR_GUWID}'] = '<GuWID>'.$replacement['{VAR_GUWID}'].'</GuWID>';
    } else {
      $replacement['{VAR_GUWID}'] = '';
    }

    if ($is3DS){
      $text_xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<WIRECARD_BXML xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" xsi:noNamespaceSchemaLocation=\"wirecard.xsd\">
  <W_REQUEST>
    <W_JOB>
      <JobID>{VAR_TRANSACTION_ID}</JobID>
      <BusinessCaseSignature>{VAR_BUSINESS_CASE_SIGNATURE}</BusinessCaseSignature>
      <FNC_CC_ENROLLMENT_CHECK>
        <FunctionID>{VAR_TRANSACTION_ID}</FunctionID>
        <CC_TRANSACTION mode=\"live\">
          <TransactionID>{VAR_TRANSACTION_ID}</TransactionID>
          <SalesDate>{VAR_DATE}</SalesDate>{VAR_GUWID}
          <CommerceType>eCommerce</CommerceType>
          <Amount minorunits=\"2\">{VAR_AMOUNT}</Amount>
          <Currency>{VAR_CURRENCY}</Currency>
          <CountryCode>{VAR_COUNTRY_CODE}</CountryCode>
          <Usage>{VAR_USAGE}</Usage>
          <RECURRING_TRANSACTION>
            <Type>Initial</Type>
          </RECURRING_TRANSACTION>
          <CREDIT_CARD_DATA>
            <CreditCardNumber>{VAR_CC_NUMBER}</CreditCardNumber>
            <CVC2>{VAR_CC_CHECKCODE}</CVC2>
            <ExpirationYear>{VAR_CC_EXPDATE_YEAR}</ExpirationYear>
            <ExpirationMonth>{VAR_CC_EXPDATE_MONTH}</ExpirationMonth>
            <CardHolderName>{VAR_CC_OWNER}</CardHolderName>{VAR_MAESTRO_DATA}
          </CREDIT_CARD_DATA>
          <CONTACT_DATA>
            <IPAddress>{VAR_IP}</IPAddress>
          </CONTACT_DATA>
          <CORPTRUSTCENTER_DATA>
            <ADDRESS>
              <FirstName>{VAR_FIRSTNAME}</FirstName>
              <LastName>{VAR_LASTNAME}</LastName>
              <Address1>{VAR_STREET_ADDRESS}</Address1>
              <City>{VAR_CITY}</City>
              <ZipCode>{VAR_POSTCODE}</ZipCode>
              <Country>{VAR_COUNTRY}</Country>
              <Email>{VAR_EMAIL_ADDRESS}</Email>
            </ADDRESS>
          </CORPTRUSTCENTER_DATA>
        </CC_TRANSACTION>
      </FNC_CC_ENROLLMENT_CHECK>
    </W_JOB>
  </W_REQUEST>
</WIRECARD_BXML>";
    } else {
      $text_xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>
<WIRECARD_BXML xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" xsi:noNamespaceSchemaLocation=\"wirecard.xsd\">
  <W_REQUEST>
    <W_JOB>
      <JobID>{VAR_TRANSACTION_ID}</JobID>
      <BusinessCaseSignature>{VAR_BUSINESS_CASE_SIGNATURE}</BusinessCaseSignature>
      <FNC_CC_TRANSACTION>
        <FunctionID>{VAR_TRANSACTION_ID}</FunctionID>
        <CC_TRANSACTION mode=\"live\">
          <TransactionID>{VAR_TRANSACTION_ID}</TransactionID>{VAR_GUWID}
          <Amount>{VAR_AMOUNT}</Amount>
          <Currency>{VAR_CURRENCY}</Currency>
          <CountryCode>{VAR_COUNTRY_CODE}</CountryCode>
          <RECURRING_TRANSACTION>
            <Type>Single</Type>
          </RECURRING_TRANSACTION>
          <CREDIT_CARD_DATA>
            <CreditCardNumber>{VAR_CC_NUMBER}</CreditCardNumber>
            <ExpirationYear>{VAR_CC_EXPDATE_YEAR}</ExpirationYear>
            <ExpirationMonth>{VAR_CC_EXPDATE_MONTH}</ExpirationMonth>
            <CVC2>{VAR_CC_CHECKCODE}</CVC2>
            <CardHolderName>{VAR_CC_OWNER}</CardHolderName>{VAR_MAESTRO_DATA}
          </CREDIT_CARD_DATA>
          <CORPTRUSTCENTER_DATA>
            <ADDRESS>
              <Address1>{VAR_STREET_ADDRESS}</Address1>
              <Address2></Address2>
              <City>{VAR_CITY}</City>
              <ZipCode>{VAR_POSTCODE}</ZipCode>
              <State />
              <Country>{VAR_COUNTRY}</Country>
              <Phone />
              <Email>{VAR_EMAIL_ADDRESS}</Email>
            </ADDRESS>
          </CORPTRUSTCENTER_DATA>
          <CONTACT_DATA>
          </CONTACT_DATA>
        </CC_TRANSACTION>
      </FNC_CC_TRANSACTION>
    </W_JOB>
  </W_REQUEST>
</WIRECARD_BXML>";
    }
    $text_xml = strtr($text_xml, $replacement);
    return $text_xml;
  }/*}}}*/

  function doWCXMLRequest($user_id, $user_pwd, $signature, $text_xml, $is3DS, $oldData)/*{{{*/
  {
    if (MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH != 'NONE')
    {
      $curl_path = MODULE_PAYMENT_WIRECARD_CCARD_CURL_PATH;
      $post_url = MODULE_PAYMENT_WIRECARD_CCARD_URL;
      $args = '-m 300 -s -S -L';		// default curl args; 5 min. timeout, followlocation
      $authorization = '-u ' . $user_id . ':' . $user_pwd;
      $headers = 'Business Case Signature : ' . $signature . "\n" .
        'Content-Type : text/xml';
      $text_xml = str_replace("\"", "\\\"", $text_xml);
      exec ("'$curl_path' $args $authorization -H '$headers' -d \"$text_xml\" '$post_url'", $response);
      $response = implode ("\n", $response);
      if (!tep_not_null($response))
      {
        $args .= ' -k';
        exec ("'$curl_path' $args $authorization -H '$headers' -d \"$text_xml\" '$post_url'", $response);
        $response = implode ("\n", $response);
      }
    } else {
      // Proxydaten prfen
      $prox = $this->proxyhost.$this->proxyport.$this->proxyuser.$this->proxypass;
      $needProxy = false;
      if (!empty($prox)) $needProxy = true;

      $ch = curl_init (); 
      curl_setopt ($ch, CURLOPT_URL, MODULE_PAYMENT_WIRECARD_CCARD_URL); 
      curl_setopt ($ch, CURLOPT_HEADER, 0);
      curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
      curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 60);
      curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST,0);
      curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
      curl_setopt ($ch, CURLOPT_USERAGENT, "WireCard Payment Request");
      curl_setopt ($ch, CURLOPT_FAILONERROR, 1); 
      curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
      curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt ($ch, CURLOPT_USERPWD, $user_id . ':' . $user_pwd);
      $headers[0] = 'Business Case Signature : ' . $signature;
      $headers[1] = 'Content-Type : text/xml';
      curl_setopt ($ch, CURLOPT_HTTPHEADER, $headers);
      curl_setopt ($ch, CURLOPT_POST, 1); 
      curl_setopt ($ch, CURLOPT_POSTFIELDS, $text_xml);

      if ($needProxy){
        curl_setopt($ch, CURLOPT_PROXY, $this->proxyhost.':'.$this->proxyport);
        curl_setopt($ch, CURLOPT_PROXYUSERPWD, $this->proxyuser.':'.$this->proxypass);
      }

      $response = curl_exec ($ch);
      $curl_err = curl_error($ch);
      curl_close ($ch);
    }
    if ($is3DS){
      // Wenn 3DS versucht aber enrollment sagt kein 3DS, dann normaler Ablauf
      $retarr = $this->decodeXML($response);
      if (!isset($retarr['PAReq']) || !isset($retarr['AcsUrl'])){
        $oldData['GuWID'] = $retarr['GuWID'];
        $text_xml = $this->getPaymentXML($oldData, false);
        if (MODULE_PAYMENT_WIRECARD_CCARD_DEBUG == 'true'){ 
          echo "<pre>"; echo htmlspecialchars($text_xml); echo "</pre>";
        }
        return $this->doWCXMLRequest($user_id, $user_pwd, $signature, $text_xml, false, $oldData);
      }
    }
    return $response;
  }/*}}}*/
  
}
?>
