<?php
/*
  $Id: wire_card_c3_sidd.php,v 1.1.1.1 2004/12/07 11:15:23 pschapler Exp $

  Copyright (c) 2004 B2Services Inc

  Created by Andrew Krolivets
*/

  class wire_card_c3_sidd {
    var $code, $title, $description, $enabled, $xml;
    var $proxyhost  = '';
    var $proxyport  = '';
    var $proxyuser  = '';
    var $proxypass  = '';


// class constructor
    function wire_card_c3_sidd() {
      global $order;

      $this->code = 'wire_card_c3_sidd';
      $this->title = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_WIRE_CARD_C3_SIDD_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
            '    var first_name = document.checkout_payment.wire_card_c3_sidd_first_name.value;' . "\n" .
            '    var last_name = document.checkout_payment.wire_card_c3_sidd_last_name.value;' . "\n" .
            '    var account_number = document.checkout_payment.wire_card_c3_sidd_account_number.value;' . "\n" .
//            '    var account_type = document.checkout_payment.wire_card_c3_sidd_account_type.value;' . "\n" .
            '    var bank_code = document.checkout_payment.wire_card_c3_sidd_bank_code.value;' . "\n" .
//            '    var bank_country = document.checkout_payment.wire_card_c3_sidd_bank_country.value;' . "\n" .
//            '    var check_number = document.checkout_payment.wire_card_c3_sidd_check_number.value;' . "\n" .
            '    if (first_name == "" || first_name.length < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_FIRST_NAME . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    if (last_name == "" || last_name.length < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_LAST_NAME . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    if (account_number == "" || account_number.length < ' . SIDD_DATA_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_ACCOUNT_NUMBER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
//            '    if (account_type == "") {' . "\n" .
//            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_ACCOUNT_TYPE . '";' . "\n" .
//            '      error = 1;' . "\n" .
//            '    }' . "\n" .
            '    if (bank_code == "" || bank_code.length < ' . SIDD_DATA_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_BANK_CODE . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
//            '    if (bank_country == "") {' . "\n" .
//            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_BANK_COUNTRY . '";' . "\n" .
//            '      error = 1;' . "\n" .
//            '    }' . "\n" .
//            '    if (check_number == "" || check_number.length < ' . SIDD_DATA_MIN_LENGTH . ') {' . "\n" .
//            '      error_message = error_message + "' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_JS_CHECK_NUMBER . '";' . "\n" .
//            '      error = 1;' . "\n" .
//            '    }' . "\n" .
            '  }' . "\n";

      return $js;
    }

    function selection() {
      global $order, $wc;

      $customerId = $_SESSION['customer_id'];
      //if ($wc->getCustomerStopLight($customerId) < WC_CLEAR_GREEN) return false;

      $countries_array = array(array('id' => '', 'text' => PULL_DOWN_DEFAULT));
      $countries = tep_db_query("select countries_name, countries_iso_code_2 from " . TABLE_COUNTRIES . " order by countries_name");
      while ($countries_values = tep_db_fetch_array($countries)) {
        $countries_array[] = array('id' => $countries_values['countries_iso_code_2'], 'text' => $countries_values['countries_name']);
      }

      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array(array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_FIRST_NAME,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_first_name', $order->billing['firstname'])),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_LAST_NAME,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_last_name', $order->billing['lastname'])),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_ACCOUNT_NUMBER,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_account_number')),
//                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_ACCOUNT_TYPE,
//                                                 'field' => tep_draw_radio_field('wire_card_c3_sidd_account_type', 'C', true, 'align="absmiddle" id="C"') . '&nbsp;<label for="C">' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_CHECKING . '</label>&nbsp;' . tep_draw_radio_field('wire_card_c3_sidd_account_type', 'S', false, 'align="absmiddle" id="S"') . '&nbsp;<label for="S">' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_SAVINGS . '</label>'),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_BANK_CODE,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_bank_code'))/*,
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_BANK_COUNTRY,
                                                 'field' => tep_draw_pull_down_menu('wire_card_c3_sidd_bank_country', $countries_array, $order->billing['country']['iso_code_2'], 'style="width:200px"')),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_CHECK_NUMBER,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_check_number')),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_IDENTIFICATION_NUMBER,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_identification_number')),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_LICENSE_NUMBER,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_license_number')),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_LICENSE_STATE,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_license_state')),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_LICENSE_COUNTRY,
                                                 'field' => tep_draw_pull_down_menu('wire_card_c3_sidd_license_country', $countries_array, '', 'style="width:200px"')),
                                           array('title' => MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TEXT_TAX_IDENTIFICATION_NUMBER,
                                                 'field' => tep_draw_input_field('wire_card_c3_sidd_tax_identification_number'))*/));

      return $selection;
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $HTTP_POST_VARS;

      $process_button_string = tep_draw_hidden_field('wire_card_c3_sidd_first_name', $HTTP_POST_VARS['wire_card_c3_sidd_first_name']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_last_name', $HTTP_POST_VARS['wire_card_c3_sidd_last_name']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_account_number', $HTTP_POST_VARS['wire_card_c3_sidd_account_number']) .
//                               tep_draw_hidden_field('wire_card_c3_sidd_account_type', $HTTP_POST_VARS['wire_card_c3_sidd_account_type']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_bank_code', $HTTP_POST_VARS['wire_card_c3_sidd_bank_code']) /*.
                               tep_draw_hidden_field('wire_card_c3_sidd_bank_country', $HTTP_POST_VARS['wire_card_c3_sidd_bank_country']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_check_number', $HTTP_POST_VARS['wire_card_c3_sidd_check_number']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_identification_number', $HTTP_POST_VARS['wire_card_c3_sidd_identification_number']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_license_number', $HTTP_POST_VARS['wire_card_c3_sidd_license_number']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_license_state', $HTTP_POST_VARS['wire_card_c3_sidd_license_state']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_license_country', $HTTP_POST_VARS['wire_card_c3_sidd_license_country']) .
                               tep_draw_hidden_field('wire_card_c3_sidd_tax_identification_number', $HTTP_POST_VARS['wire_card_c3_sidd_tax_identification_number'])*/;

      return $process_button_string;
    }

    function before_process() {
      global $HTTP_POST_VARS, $order, $currency, $currencies;
      
      $transaction_id = md5(uniqid('', 1));
      if(function_exists('iconv'))
      {
        $transaction_mode = iconv(CHARSET, 'UTF-8', MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TRANSACTION_MODE);
        $business_case_signature = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE;
        $amount = (int)(tep_round($order->info['total'] * $currencies->currencies[$currency]['value'] / $currencies->currencies[DEFAULT_CURRENCY]['value'], $currencies->currencies[$currency]['decimal_places']) * pow(10, $currencies->currencies[$currency]['decimal_places'])); // integer amount, in smallest currency unit

        $first_name = iconv(CHARSET, 'UTF-8', $HTTP_POST_VARS['wire_card_c3_sidd_first_name']);
        $last_name = iconv(CHARSET, 'UTF-8', $HTTP_POST_VARS['wire_card_c3_sidd_last_name']);
        $account_number = iconv(CHARSET, 'UTF-8', $HTTP_POST_VARS['wire_card_c3_sidd_account_number']);
        $account_type = 'C'; //iconv(CHARSET, 'UTF-8', $HTTP_POST_VARS['wire_card_c3_sidd_account_type']);
        $bank_code = iconv(CHARSET, 'UTF-8', $HTTP_POST_VARS['wire_card_c3_sidd_bank_code']);
        $bank_country = $order->billing['country']['iso_code_2']; //iconv(CHARSET, 'UTF-8', $HTTP_POST_VARS['wire_card_c3_sidd_bank_country']);
        $street_address = iconv(CHARSET, 'UTF-8', $order->customer['street_address']);
        $suburb = iconv(CHARSET, 'UTF-8', $order->customer['suburb']);
        $city = iconv(CHARSET, 'UTF-8', $order->customer['city']);
        $postcode = iconv(CHARSET, 'UTF-8', $order->customer['postcode']);
        $state = iconv(CHARSET, 'UTF-8', $order->customer['state']);
        $country = $order->customer['country']['iso_code_2'];
        $telephone = iconv(CHARSET, 'UTF-8', $order->customer['telephone']);
        $email_address = iconv(CHARSET, 'UTF-8', $order->customer['email_address']);
      } else {
        $transaction_mode = utf8_encode(MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TRANSACTION_MODE);
        $business_case_signature = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE;
        $amount = (int)(tep_round($order->info['total'] * $currencies->currencies[$currency]['value'] / $currencies->currencies[DEFAULT_CURRENCY]['value'], $currencies->currencies[$currency]['decimal_places']) * pow(10, $currencies->currencies[$currency]['decimal_places'])); // integer amount, in smallest currency unit

        $first_name = utf8_encode($HTTP_POST_VARS['wire_card_c3_sidd_first_name']);
        $last_name = utf8_encode($HTTP_POST_VARS['wire_card_c3_sidd_last_name']);
        $account_number = utf8_encode($HTTP_POST_VARS['wire_card_c3_sidd_account_number']);
        $account_type = 'C'; //utf8_encode($HTTP_POST_VARS['wire_card_c3_sidd_account_type']);
        $bank_code = utf8_encode($HTTP_POST_VARS['wire_card_c3_sidd_bank_code']);
        $bank_country = $order->billing['country']['iso_code_2']; //utf8_encode($HTTP_POST_VARS['wire_card_c3_sidd_bank_country']);
        $street_address = utf8_encode($order->customer['street_address']);
        $suburb = utf8_encode($order->customer['suburb']);
        $city = utf8_encode($order->customer['city']);
        $postcode = utf8_encode($order->customer['postcode']);
        $state = utf8_encode($order->customer['state']);
        $country = $order->customer['country']['iso_code_2'];
        $telephone = utf8_encode($order->customer['telephone']);
        $email_address = utf8_encode($order->customer['email_address']);
      }

      $text_xml = <<<TEXT_XML_LABEL
<?xml version="1.0" encoding="UTF-8"?>
<WIRECARD_BXML xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xsi:noNamespaceSchemaLocation="wirecard.xsd">
  <W_REQUEST>
    <W_JOB>
      <JobID>job 1</JobID>
      <BusinessCaseSignature>$business_case_signature</BusinessCaseSignature>
      <FNC_FT_DEBIT>
        <FunctionID>transaction 1</FunctionID>
        <FT_TRANSACTION mode="$transaction_mode">
          <TransactionID>$transaction_id</TransactionID>
          <EXTERNAL_ACCOUNT>
            <FirstName>$first_name</FirstName>
            <LastName>$last_name</LastName>
            <AccountNumber>$account_number</AccountNumber>
            <AccountType>$account_type</AccountType>
            <BankCode>$bank_code</BankCode>
            <Country>$bank_country</Country>
            <CheckNumber>$check_number</CheckNumber>
            <COUNTRY_SPECIFIC>
              <IdentificationNumber>$identification_number</IdentificationNumber>
            </COUNTRY_SPECIFIC>
          </EXTERNAL_ACCOUNT>
          <Amount>$amount</Amount>
          <Currency>$currency</Currency>
          <CORPTRUSTCENTER_DATA>
            <ADDRESS>
              <Address1>$street_address</Address1>
              <Address2>$suburb</Address2>
              <City>$city</City>
              <ZipCode>$postcode</ZipCode>
              <State>$state</State>
              <Country>$country</Country>
              <Phone>$telephone</Phone>
              <Email>$email_address</Email>
            </ADDRESS>
            <PERSONINFO>
              <DRIVERS_LICENSE>
                <LicenseNumber>$license_number</LicenseNumber>
                <State>$license_state</State>
                <Country>$license_country</Country>
              </DRIVERS_LICENSE>
              <TaxIdentificationNumber>$tax_identification_number</TaxIdentificationNumber>
            </PERSONINFO>
          </CORPTRUSTCENTER_DATA>
        </FT_TRANSACTION>
      </FNC_FT_DEBIT>
    </W_JOB>
  </W_REQUEST>
</WIRECARD_BXML>
TEXT_XML_LABEL;
// <?php // Code insight BUG
      #echo "<pre>"; echo htmlspecialchars($text_xml); echo "</pre>";

      unset($response);
      if (MODULE_PAYMENT_WIRE_CARD_C3_SIDD_CURL_PATH != 'NONE' && MODULE_PAYMENT_WIRE_CARD_C3_SIDD_CURL_PATH != 'SOCKS')
      {
        $curl_path = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_CURL_PATH;
        $post_url = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_URL;
        $args = '-m 300 -s -S -L';    // default curl args; 5 min. timeout, followlocation
        $authorization = '-u ' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_USER_ID . ':' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_PASSWORD;
        $headers = 'Business Case Signature : ' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE . "\n" .
                   'Content-Type : text/xml';
        $text_xml = str_replace("\"", "\\\"", $text_xml);
        exec ("'$curl_path' $args $authorization -H '$headers' -d \"$text_xml\" '$post_url'", $response);
        $response = implode ("\n", $response);
        if (!tep_not_null($response))
        {
          $args .= ' -k';
          exec ("'$curl_path' $args $authorization -H '$headers' -d \"$text_xml\" '$post_url'", $response);
          $response = implode ("\n", $response);
        }
      }
      elseif (MODULE_PAYMENT_WIRE_CARD_C3_SIDD_CURL_PATH == 'SOCKS')
      {
        $this->xml = $text_xml;
        $response = $this->process_request();
      }
      else
      {
         // Proxydaten prfen
        $prox = $this->proxyhost.$this->proxyport.$this->proxyuser.$this->proxypass;
        $needProxy = false;
        if (!empty($prox)) $needProxy = true;
        
        $ch = curl_init ();
        curl_setopt ($ch, CURLOPT_URL, MODULE_PAYMENT_WIRE_CARD_C3_SIDD_URL);
        curl_setopt ($ch, CURLOPT_HEADER, 0);
        curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 60);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST,0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_USERAGENT, "WireCard Payment Request");
        curl_setopt ($ch, CURLOPT_FAILONERROR, 1); 
        curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt ($ch, CURLOPT_USERPWD, MODULE_PAYMENT_WIRE_CARD_C3_SIDD_USER_ID . ':' .
                                           MODULE_PAYMENT_WIRE_CARD_C3_SIDD_PASSWORD);
        $headers[0] = 'Business Case Signature : ' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE;
        $headers[1] = 'Content-Type : text/xml';
        curl_setopt ($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt ($ch, CURLOPT_POST, 1);
        curl_setopt ($ch, CURLOPT_POSTFIELDS, $text_xml);

        if ($needProxy){
          curl_setopt($ch, CURLOPT_PROXY, $this->proxyhost.':'.$this->proxyport);
          curl_setopt($ch, CURLOPT_PROXYUSERPWD, $this->proxyuser.':'.$this->proxypass);
        }
        $response = curl_exec ($ch);
        $curl_err = curl_error($ch);
        curl_close ($ch);
      }
      #echo "<pre>"; echo htmlspecialchars($response); echo "</pre>";
      $retarr = $this->decodeXML($response);
      #echo "<pre>"; print_r($retarr); echo "</pre>"; exit;

      if ($retarr['FunctionResult'] != 'ACK')
      {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(WIRE_CARD_C3_SIDD_ERROR_HEADING . ' ' . ($retarr['Message'] ? $retarr['Message'] : WIRE_CARD_C3_SIDD_ERROR_CURL).$curl_err), 'SSL', true, false));
      }
      $this->GuWID = $retarr['GuWID'];
    }


    function process_request() {

      $requestHeaders = array();

      $url = parse_url(MODULE_PAYMENT_WIRE_CARD_C3_SIDD_URL);

      $requestHeaders["Authorization"] = 'Basic ' . base64_encode(MODULE_PAYMENT_WIRE_CARD_C3_SIDD_USER_ID . ':' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_PASSWORD);
      $requestHeaders["Business Case Signature"] = MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE;
      $requestHeaders["Content-Type"] = 'text/xml';
      $requestHeaders["Content-Length"] = strlen($this->xml);
      $requestHeaders["Connection"] = 'close';

      $command = 'POST ' . MODULE_PAYMENT_WIRE_CARD_C3_SIDD_URL.' HTTPS/1.0';
      $cmd = $command . "\r\n";

      reset($requestHeaders);
      while (list($k, $v) = each($requestHeaders)) {
       $cmd .= $k . ': ' . $v . "\r\n";
      }
      $cmd .= "\r\n" . $this->xml;

      $socket = fsockopen( "ssl://".$url["host"], 443, $reply, $replyString );
      if ($socket) {
        fputs($socket, $cmd . "\r\n");

        $data = '';
        $counter = 0;

        do {
          $status = socket_get_status($socket);
          if ($status['eof'] == 1) {
            break;
          }

          if ($status['unread_bytes'] > 0) {
            $buffer = fread($socket, $status['unread_bytes']);
            $counter = 0;
          } else {
            $buffer = fread($socket, 128);
            $counter++;
            usleep(2);
          }

          $data .= $buffer;
        } while ( ($status['unread_bytes'] > 0) || ($counter++ < 10) );

      }
      fclose($socket);

      return $data;
    }

    function after_process() {
      global $insert_id;
      tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_wirecard_guwid = '" . tep_db_input($this->GuWID) . "' WHERE orders_id = '" . (int)$insert_id . "'");
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => WIRE_CARD_C3_SIDD_ERROR_HEADING,
                     'error' => ((isset($HTTP_GET_VARS['error'])) ? stripslashes(urldecode($HTTP_GET_VARS['error'])) : WIRE_CARD_C3_SIDD_ERROR_MESSAGE));

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Wire Card C3 Module', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_STATUS', 'True', 'Do you want to accept Wire Card C3 payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Wire Card HTTPS Gateway URL', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_URL', 'https://c3-test.wirecard.com/secure/ssl-gateway', 'URL of the HTTPS Gateway of the Wire Card II RPI platform offers a flexible and secure communication for FirePay payment requests and responses.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('User ID', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_USER_ID', '56500', 'The user ID for the Wire Card C3 service', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('User Password', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_PASSWORD', 'TestXAPTER', 'The user password for the Wire Card C3 service', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Business Case Signature', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE', '56500', 'The Business Case Signature for the Wire Card C3 service', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TRANSACTION_MODE', 'demo', 'This defines the mode of the transaction. Valid values are: (<b>live</b> or <b>demo</b>). The demo transactions are not submitted to the financial institution.', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('CURL Path', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_CURL_PATH', '/usr/bin/curl', 'Path to CURL binary. (NONE - use built-in PHP CURL methods, SOCKS - use sockets).', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_WIRE_CARD_C3_SIDD_STATUS', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_URL', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_USER_ID', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_PASSWORD', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_BUSINESS_CASE_SIGNATURE', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_TRANSACTION_MODE', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ZONE', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_ORDER_STATUS_ID', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_CURL_PATH', 'MODULE_PAYMENT_WIRE_CARD_C3_SIDD_SORT_ORDER');
    }

    function decodeXML($xmlstg)
    {
      preg_match_all ("(<([a-z0-9]+)>([^<>]*?)</[a-z0-9]+>)i", $xmlstg, $out, PREG_SET_ORDER);

      $n = 0;
      while (isset($out[$n]))
      {
        $retarr[$out[$n][1]] = strip_tags($out[$n][2]);
        $n++;
      }

      return $retarr;
    }
  }
?>
